;LinkMan v0.1
; (C) 2007 by Brandon Wilson. All rights reserved. 

;v0.1 Changelog
;Initial release

;To Do:
;Add logging
;Get programs running properly (on the homescreen, for example) in hook
;Add ability to send X-Link appvars and finish menus
;Add hook code to receive X-Link and 83+ variables
;Duplicate all the other TI-OS silent link hook code (remote program execution, etc.)

 include "settings.inc"
 NOLIST
 include "ti83plus.inc"
 LIST
 include "equates.inc"
 include "header.asm"

 SEGMENT MAIN
 GLOBALS ON

 EXTERN DialogBox,VPutSApp,VPutSAppCenter,linkActivityHook,getCSCHook,PutSApp,ReceiveOS
 EXTERN Send85,Send86,Send89,Send92,Send92Plus,SendVoyage200,cursorHook,silentLinkHook
 EXTERN ViewLog,ConfigureLinkMan

 Var menuTable,2                   ;pointer to current menu
 Var prevMenu,2                    ;pointer to previous menu routine
 Var curChoice,1                   ;current menu choice
 Var maxChoice,1                   ;maximum menu choice (31h-37h)
 Var tempByte,1                    ;temporary byte for whatever
 Var currentOffset,2               ;current Flash offset
 Var currentPage,1                 ;current Flash page
 Var Abackup,1                     ;backup of A for BCALL replacement
 Var DEbackup,2                    ;backup of DE for BCALL replacement
 Var HLbackup,2                    ;backup of HL for BCALL replacement
 Var BCbackup,2                    ;backup of BC for BCALL replacement
 Var machineID,1                   ;machine ID used in link routines
 Var curVarType,1                  ;current variable type from findCompatibleAppVar search

StartApp:
       call loadAppVar
       B_CALL NZIf83Plus
       ld hl,mainMenu
       ld a,35h ;37h
       jr z,$F
       ld hl,mainMenu83P
       ld a,35h ;36h
$$:    ld (menuTable),hl
       ld hl,0
       ld (prevMenu),hl
       ld (maxChoice),a
DrawMenu:
       B_CALL ClrLCDFull
       ld de,0
       ld (curRow),de
       ld hl,(menuTable)
       set textInverse,(iy+textFlags)
       call PutSApp
       res textInverse,(iy+textFlags)
       ld de,1
       ld (curRow),de
       ld b,31h
       ld a,b
       ld (curChoice),a
displayLoop:
       ld a,(curChoice)
       cp b
       jr nz,$F
       set textInverse,(iy+textFlags)
$$:    ld a,b
       inc b
       B_CALL PutC
       ld a,':'
       B_CALL PutC
       res textInverse,(iy+textFlags)
       call PutSApp
       ld a,(curRow)
       inc a
       ld e,a
       ld d,0
       ld (curRow),de
       inc hl
       inc hl
       ld a,(hl)
       or a
       jr nz,displayLoop
keyLoop:
       B_CALL GetKey
       cp kQuit
       jr z,ExitApp
       cp kClear
       jr z,previousMenu
       cp kUp
       jr z,menuUp
       cp kDown
       jr z,menuDown
       cp kEnter
       jr nz,$F
       ld a,(curChoice)
       sub 30h
       jr execChoice
$$:    cp k0
       jp m,keyLoop
       cp kCapZ
       jp p,keyLoop
       sub k0
execChoice:
       ld hl,(menuTable)
       or a
       jr nz,$F
       ld a,10
$$:    ld d,a
       xor a
       ld bc,0FFFh
       cpir
       ld c,d
searchLoop:
       ld a,(hl)
       or a
       jr z,keyLoop
       push bc
       xor a
       ld bc,0FFFFh
       cpir
       pop bc
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       dec c
       jr nz,searchLoop
       ex de,hl
       jp (hl)
previousMenu:
       ld hl,(prevMenu)
       ld a,h
       or l
       jr z,ExitApp
       jp (hl)
menuUp:
       ld a,(curChoice)
       dec a
       cp 30h
       jr z,keyLoop
       jr $F
menuDown:
       ld a,(maxChoice)
       ld b,a
       ld a,(curChoice)
       cp b
       jr z,keyLoop
       inc a
$$:    push af
       ld a,(curChoice)
       ld de,0
       ld (curRow),de
       sub 30h
       ld (curRow),a
       add a,30h
       B_CALL PutC
       ld a,':'
       B_CALL PutC
       pop af
       ld (curChoice),a
       ld (curRow),de
       sub 30h
       ld (curRow),a
       set textInverse,(iy+textFlags)
       add a,30h
       B_CALL PutC
       ld a,':'
       B_CALL PutC
       res textInverse,(iy+textFlags)
       jr keyLoop
InstallHooks:
       res textWrite,(iy+sGrFlags)
       B_CALL GrBufClr
       in a,(6)
       ld hl,silentLinkHook
       B_CALL EnableSilentLinkHook
       ld l,13
	ld h,15
	ld e,79
	ld d,47
       call DialogBox
       ld hl,sHooksInstalled
       ld a,20
       ld (penRow),a
       call VPutSAppCenter
       ld a,35
       ld (penRow),a
       ld hl,sPressAnyKey
       call VPutSAppCenter
       B_CALL GetKey
       jr StartApp
UninstallHooks:
       res textWrite,(iy+sGrFlags)
       B_CALL GrBufClr
       B_CALL DisableSilentLinkHook
       ld l,10
       ld h,15
       ld e,82
       ld d,47
       call DialogBox
       ld hl,sHooksUninstalled
       ld a,20
       ld (penRow),a
       call VPutSAppCenter
       ld a,35
       ld (penRow),a
       call VPutSAppCenter
       B_CALL GetKey
       jr StartApp
SendVars:
       ld hl,StartApp
       ld (prevMenu),hl
       ld hl,selectCalc
       ld (menuTable),hl
       ld a,36h
       ld (maxChoice),a
       jr DrawMenu
ExitApp:
       B_CALL ClrLCDFull
       B_JUMP JForceCmdNoChar
loadAppVar:
       ld hl,sLinkManAppVar
       rst 20h
       B_CALL ChkFindSym
       call c,createLinkManAppVar
       ld hl,4
       add hl,de
       ld a,b
       or a
       jr z,$F
       ld de,17
       add hl,de
$$:    ld de,appData
       ld bc,APPVAR_SIZE-2
       B_CALL FlashToRam
       ret
createLinkManAppVar:
       ld hl,APPVAR_SIZE
       B_CALL CreateAppVar
       ex de,hl
       inc hl
       inc hl
       ld (hl),72h
       inc hl
       ld (hl),85h
       inc hl
       ld bc,48
       B_CALL MemClear
       B_CALL ChkFindSym
       ret
sHooksInstalled:
       DB "LinkMan Installed",0
sHooksUninstalled:
       DB "LinkMan Uninstalled",0
sPressAnyKey:
       DB "Press any key...",0
mainMenu:
       DB "Link Manager",0
       DB "Install",0
       DW InstallHooks
       DB "Uninstall",0
       DW UninstallHooks
       DB "Configure",0CEh,0
       DW ConfigureLinkMan
;       DB "Send Vars",0CEh,0
;       DW SendVars
       DB "Receive OS",0CEh,0
       DW ReceiveOS
;       DB "Logging",0CEh,0
;       DW ViewLog
       DB "Quit",0
       DW ExitApp
       DB 0
mainMenu83P:
       DB "Link Manager",0
       DB "Install",0
       DW InstallHooks
       DB "Uninstall",0
       DW UninstallHooks
       DB "Configure",0CEh,0
       DW ConfigureLinkMan
;       DB "Send Vars",0CEh,0
;       DW SendVars
       DB "Receive OS",0CEh,0
       DW ReceiveOS
       DB "Quit",0
       DW ExitApp
       DB 0
selectCalc:
       DB "Select Device",0
       DB "TI-85",0CEh,0
       DW Send85
       DB "TI-86",0CEh,0
       DW Send86
       DB "TI-89",0CEh,0
       DW Send89
       DB "TI-92",0CEh,0
       DW Send92
       DB "TI-92 Plus",0CEh,0
       DW Send92Plus
       DB "Voyage 200",0CEh,0
       DW SendVoyage200
       DB 0
sLinkManAppVar:
       DB AppVarObj,"LinkMan",0
